import subprocess
import time
from pyautogui import position
import matplotlib.pyplot as plt
import matplotlib.cm as cm
import seaborn as sns
import pandas as pd
import datetime
import os


def expandcoordinates(x, y, w1, h1, w2, h2):
    wr = min(w1, w2) / max(w1, w2)
    hr = min(h1, h2) / max(h1, h2)
    x = x / wr
    y = y / hr
    return int(x), int(y)


def getposwrite(tX, tY, bX, bY, w, h, filename):
    if not os.path.exists(os.getcwd()+"/src/datas/" + filename + ".csv"):
        file = open("src/datas/" + filename + ".csv", "a+")
        file.write("x,y\n")
        file.close()
    file = open("src/datas/" + filename + ".csv", "a+")
    mX, mY = position()
    print(position())
    if tX <= mX <= bX and tY <= mY <= bY:
        mX -= tX
        mY -= tY
        mX, mY = expandcoordinates(mX, mY, w, h, 1920, 1080)
        file.write("{},{}\n".format(mX, mY))
    file.close()


def plotheatmap(filename):
    dx = pd.read_csv("src/datas/" + filename + ".csv", delimiter=",")["x"]
    dy = pd.read_csv("src/datas/" + filename + ".csv", delimiter=",")["y"]

    g = sns.jointplot(
        x=dx,
        y=dy,
        kind="kde",
        cmap=cm.jet,
        fill=True,
        shade_lowest=True,
        thresh=0
    )
    plt.gca().invert_yaxis()
    # plt.show()
    plt.savefig("src/plots/" + filename + ".png")


def listwindowprocess():
    a = 'wmctrl -lp'
    print(a)

    listwindowsprocess = subprocess.run(a, shell=True, capture_output=True, encoding="utf-8")

    cikti = str(listwindowsprocess.stdout)
    liste = cikti.split("\n")
    liste = list(filter(None, liste))
    for index, element in enumerate(liste):
        print("{} {}".format(index, element))
    istek = int(input("\nSeçmek istediğiniz pencerenin indexini giriniz : "))
    ab = list(filter(None, liste[istek].split(" ", maxsplit=7)))
    win_id, desktop_id, process_id, user, windowname = ab

    return win_id, desktop_id, process_id, user, windowname


def getactivewindow():
    getactivewindow = subprocess.run("xdotool getwindowfocus getwindowname", shell=True, capture_output=True,
                                     encoding="utf-8")
    getactivewindowoutput = str(getactivewindow.stdout)
    return getactivewindowoutput.strip()


def getwininfo(win_id):
    getwininfo = subprocess.run("xwininfo -id {}".format(win_id), capture_output=True, shell=True, encoding="utf-8")
    wininfooutput = str(getwininfo.stdout)

    list2 = wininfooutput.split("\n")
    list2 = list(filter(None, list2))
    aX, aY, rX, rY, w, h = list2[1:7]

    aX, aY, rX, rY, w, h = int(aX.split(" ")[-1]), int(aY.split(" ")[-1]), int(rX.split(" ")[-1]), int(
        rY.split(" ")[-1]), int(w.split(" ")[-1]), int(h.split(" ")[-1])
    tX, tY, bX, bY = aX + rX, aY + rY, aX + rX + w, aY + rY + h
    return tX, tY, bX, bY, w, h


if not os.path.exists("src"):
    os.makedirs("src")
if not os.path.exists(os.path.join(os.getcwd())+"/src/datas"):
    os.makedirs(os.path.join(os.getcwd())+"/src/datas")
if not os.path.exists(os.path.join(os.getcwd())+"/src/plots"):
    os.makedirs(os.path.join(os.getcwd())+"/src/plots")
win_id, _, _, _, windowname = listwindowprocess()

nowtime = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
filename = nowtime + " - " + windowname

minute = float(input("Programın kaç dakika çalışmasını istersiniz ? : "))
minute *= 60 / 0.2
while minute > 0:
    if windowname == getactivewindow():
        tX, tY, bX, bY, w, h = getwininfo(win_id)
        print(tX, tY, bX, bY)
        getposwrite(tX, tY, bX, bY, w, h, filename)
    time.sleep(0.2)
    minute -= 1
plotheatmap(filename)
print("Veriler src dosya dizinine kaydedildi.")
